<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/tags/release-3.0.0-RC1/class/auth.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Michael Clay <claym@osuosl.org>                             |
// +------------------------------------------------------------------------+
// $Id: auth.php 3992 2005-11-08 21:25:54Z wenzel $

/**
  * auth.php - contains PEAR_Auth extensions
  * This document contains overrides for the PEAR_Auth package allowing
  * us to authenticate users over MySQL and LDAP easily
  *
  * @author $Author: wenzel $
  * @filesource
  * @package    classes
  * @subpackage auth
  */

require_once "Auth/Container/DB.php";
require_once "Auth/Container/LDAP.php";
require_once "Auth.php";

/**
  * Overloaded methods from PEAR_Auth, allowing us to ignore magic_quotes
  * settings, and modify the session information
  *
  * @package    classes
  * @subpackage auth
  */
class MaintAuth extends Auth {

   //{{{ setAuthVars()

    /**
     * This method allows you to specify the user and pass you want to auth against.
     * If this method is not called then by default it will check the $_POST.
     *
     * @access public
     * @param string $username the user name we're trying to auth
     * @param string $password the password for the user we're trying to auth
     * @return void
     */
    function setAuthVars($username, $password){
        if ($username != '') {
            $this->username = (get_magic_quotes_gpc() == 1 ? stripslashes($username) : $username);
        }
        if ($password != '') {
            $this->password = (get_magic_quotes_gpc() == 1 ? stripslashes($password) : $password );
        }
    } //END setAuthVars()

    //}}}
    //{{{ start()

    /**
     * This overloads Auth's start to allow users to use setAuthVars.
     *
     * @access public
     * @return void
     */
    function start(){
        if(!strcmp($this->username,'') || !strcmp($this->password,'')){
            $this->assignData();
        }

        session_start();

        if(!$this->checkAuth()){
            $this->login();
        }
    } //END start()

    //}}}

}

?>
