<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/tags/release-3.0.0-RC1/class/htdocs/datalist/CnameDataList.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Michael Clay <claym@osuosl.org>                               |
// |          Frederic Wenzel <fred@osuosl.org>                             |
// +------------------------------------------------------------------------+
   
// $Id: CnameDataList.php 4282 2006-03-20 22:42:50Z wenzel $

/**
  * CnameDataList.php - contains the {@link CnameDataList} class
  *
  * @author $Author: wenzel $
  * @filesource
  * @package    htdocs
  * @subpackage datalists
  */

require_once(DAOEXT.'/cname.php');
require_once(HTCLASS.'/DB_DataObjectDataList.php');
require_once(HTCLASS.'/DB_DataObjectDataListSource.php');

/**
  * Table listing of CNAME objects
  *
  * @link   http://phphtmllib.newsblob.com/javadoc.php phpHtmlLib API Documentation
  * @link   http://phphtmllib.newsblob.com/doc/phpHtmlLib/DefaultGUIDatalist.html
            DefaultGUIDataList API Documentation
  * @package    htdocs
  * @subpackage datalists
  */

class CnameDataList extends DB_DataObjectDataList
{

// {{{ get_data_source()

    function get_data_source()
    {
        global $conf;

        $cname = new CNAME();
        $src = &new DB_DataObjectDataListSource($cname);
        $this->set_data_source($src);
        $this->_default_orderby = 'name';
    }

// }}}
// {{{ _user_setup()

    function _user_setup()
    {
        $this->add_header_item(_("CNAME"), '20%', 'name', SORTABLE, SEARCHABLE);
        $this->add_header_item(_("Server Name"), '20%', 'server', SORTABLE, SEARCHABLE);
        $this->add_header_item(_("Action"),'20%');
        $this->_datasource->setup_db_options(array('zone' => $_SESSION['zone']));
    }

// }}}
// {{{ build_column_item()

    function build_column_item($row_data, $col_name)
    {
        global $conf;

        switch($col_name) {
            case _('CNAME'):
                $link = web_root().'cname.php?action=show&amp;id='.
                        $row_data['id'];
                $obj = html_a($link,$row_data[_('hostname')]);
                break; 
            case _('Action'):
                $edit = html_a(web_root()."cname.php?action=edit&amp;id=".
                        $row_data['id'], _("Edit"));
                $delete = html_a(web_root()."cname.php?action=delconfirm&amp;id=".
                        $row_data['id'],_("Delete"));
                $obj = container($edit,"|",$delete);
                break;
            default:
                $obj = parent::build_column_item($row_data, $col_name);
        }

        return $obj;
    }

// }}}

}

?>
