<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/tags/release-3.0.0-RC1/class/htdocs/datalist/DHCPODataList.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Michael Clay <claym@osuosl.org>                               |
// +------------------------------------------------------------------------+
// $Id: DHCPODataList.php 4035 2005-12-15 20:03:13Z bartel $

/**
  * DHCPODataList.php - contains the {@link DHCPODataList} class
  *
  * @author $Author: bartel $
  * @filesource
  * @package    htdocs
  * @subpackage datalists
  */

require_once(DAOEXT.'/dhcpoption.php');
require_once(HTCLASS.'/DB_DataObjectDataList.php');
require_once(HTCLASS.'/DB_DataObjectDataListSource.php');

/**
  * Table listing of DHCP Options
  *
  * @link   http://phphtmllib.newsblob.com/javadoc.php phpHtmlLib API Documentation
  * @link   http://phphtmllib.newsblob.com/doc/phpHtmlLib/DefaultGUIDatalist.html
            DefaultGUIDataList API Documentation
  * @package    htdocs
  * @subpackage datalists
  */
class DHCPODataList extends DB_DataObjectDataList
{

//{{{ get_data_source()

    function get_data_source()
    {
        global $conf;

        $dhcpo = new DHCPOption();
        $src = &new DB_DataObjectDataListSource($dhcpo);
        $this->set_data_source($src);
        $this->_default_orderby = 'name';
    }

//}}}
//{{{ _user_setup()

    function _user_setup()
    {
        $this->add_header_item(_("Option"), '20%', 'name', SORTABLE, null);
        $this->add_header_item(_("Type"), '10%', 'type', SORTABLE, null);
        $this->add_header_item(_("Access Level"),'5%', 'access', SORTABLE, null);
        $this->add_header_item(_("Custom?"),'5%', 'custom', SORTABLE, null);
        $this->add_header_item(_("Custom Value"),'15%', 'value', SORTABLE, null);
        $this->add_header_item(_("Action"),'15%');
    }

//}}}
//{{{   build_column_item()
    
    function build_column_item($row_data, $col_name)
    {
        switch ($col_name)
        {
            case _('Custom?'):
                $obj = ($row_data['custom'])?"Yes":"No";
                break;
            case _('Action'):
                $obj = container(html_a(web_root()."dhcp.php?action=edit&amp;id=".
                                        $row_data['id'],_("Edit")),
                                "|",html_a(web_root()."dhcp.php?action=delete&amp;id=".$row_data['id'],_("Delete")),
                                "|",html_a(web_root()."dhcp.php?action=enable_disable&amp;id=".$row_data['id'],($row_data['enabled'])?_("Disable"):_("Enable")));
                break;
            default:
                $obj = parent::build_column_item($row_data, $col_name);
        }

        return $obj;
    }

//}}}

}

?>
