<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL$
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Zack Bartel <bartel@osuosl.org>                             |
// +------------------------------------------------------------------------+
// $Id: SearchDataList.php 3985 2006-02-22 22:53:35Z bartel $

require_once($phphtmllib.'/widgets/data_list/DefaultGUIDataList.inc');
require_once($phphtmllib."/widgets/data_list/ArrayDataListSource.inc");

class SearchDataList extends DefaultGUIDataList
{
//{{{   vars
    var $_module;
    var $_object;
    var $_fields;
    var $_default_rows_per_page = 10;
//}}}
//{{{ constructor()
    function SearchDataList($name, $module, $object)
    {
        $this->_module = $module;
        $this->_object = $object;
        parent::DefaultGUIDataList($name);
        return $this;
    }
//}}}
//{{{  get_data_source()
    /**
     *  This function sets up the data source for the data list.
     *  In this case we are using a ArrayDataListSource rather
     *  than a DB_DataObjectDataSource (as in most cases with Maintain)
     *  because the data is a list of IP Addresses that do not have a
     *  DBDO representation.
     *
     */
     
    function get_data_source()
    {
        /* set the users preferred results/page */
        global $user;
        $this->_default_rows_per_page = $user->list_view;
        
        /* Let's change this and use a Factory approach */
        $mod = new $this->_module;

        if (!isset($_REQUEST['Search']))
            return false;
        $query = $_REQUEST['Search'];

        $data = $_REQUEST['data'];

        $fields = $data[$this->_module][$this->_object];
        $type = $_REQUEST['Type'];
        
        if (!is_array($fields))
            $fields = array();
        
        $ary = $mod->search($query, $this->_object, array_flip($fields), $type);
        $source = new ArrayDataListSource($ary);
        $this->set_data_source(&$source);
        /* Give it a poitner in case we need to change it :-( */
        $this->_fields = &$mod->searchGetFields($this->_object);
    }
//}}}
//{{{   user_setup()
    /**
     *  This function sets up the table columns for the datalist 
     *  and sets attributes.
     *
     */
    function user_setup()
    {
        $mod = new $this->_module;

        $o = $this->_object;

        $disp = $mod->searchDisplayColumns($o);
        foreach ($disp as $var=>$val)
            $this->add_header_item($var, "20%");
    }
//}}}
//{{{   build_column_item()
    /**
     *  This function decides how the data will appear per row
     *  and data.
     *  
     *  @param  array   $row_data   the current row to build for
     *  @param  string  $col_name   the current column to build for
     *
     *
     *  @return Object  $obj        the custom rendering for the given data
     *
     */
    function build_column_item($row_data, $col_name)
    {
        $mod = new $this->_module;
        $obj = $mod->searchFetch($this->_object, $row_data, $this->_fields[$col_name]);
        return $obj;
    }
//}}}
}

?>
