<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL$
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Zack Bartel <bartel@osuosl.org>                             |
// +------------------------------------------------------------------------+
// $Id: 

/**
 *  ObjectOptionDeleteConfirm.php - Contains the {@link ObjectOptionDeleteConfirm}
 *                              class
 *  @author     $Author$
 *  @package    htdocs
 *  @subpackage forms
 *  @filesource
 */

require_once(FORMDIR."/MaintainDeleteConfirm.php");
/**
 *  This class is the delete confirm page
 *
 *  @package    htdocs
 *  @subpackege forms
 */
class ObjectOptionDeleteConfirm extends MaintainDeleteConfirm
{

    var $type;
    var $func;

//{{{   form_success()

    /**
     *  This method displays a message informing the pointer that the delete was
     *  successful.
     *
     *  @return DIVTag  $div   The div that contains the message
     */
    function form_success()
    {
        $type = $_REQUEST['object_type'];
        $id = $_REQUEST['object_id'];
        $div = html_div("msuccess");
        $indlink = html_a(web_root()."index.php", _("[Return to Home]"));
        $listlink = html_a($_SERVER["SCRIPT_NAME"]."?object_type=$type&amp;&object_id=$id", _("[Return to Option List]"));
        $div->add(container(_("$this->type deleted successfully!"),html_br()));
        $div->add(container($indlink, $listlink));
        return $div;
    }

//}}}
//{{{ form()
    function form()
    {
        $div = parent::form();
        $div->add(container($this->element_form("object_type"), $this->element_form("object_id")));
        return $div;
    }

//}}}
//{{{   form_init_elements()

    /**
     *  This method inits the elements that are able to be included in the form.
     */
    function form_init_elements()
    {
        $this->add_element(new FEHidden("action",$_REQUEST['action']));
        $this->add_element(new FEHidden("id", $_REQEST['id']));
        $dbdo = new Option($_REQUEST['id']);
        $this->add_element(new FEHidden("object_type", $dbdo->getType()));
        $this->add_element(new FEHidden("object_id", $dbdo->getObject_id()));
        $this->set_action($_SERVER["SCRIPT_NAME"]);
        $this->set_cancel_action($_SERVER["SCRIPT_NAME"]);
    }

//}}}

}

?>
