<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Michael Clay <claym@osuosl.org>                               |
// |          Zack Bartel  <bartel@osuosl.org>
// +------------------------------------------------------------------------+
// $Id $

require_once("includes.php");
require_once(HTCLASS."/datalist/DomainDataList.php");
require_once(FORMDIR."/DomainCreateForm.php");
require_once(FORMDIR."/MaintainDeleteConfirm.php");
require_once(FORMDIR."/DomainEditForm.php");
require_once(FORMDIR."/DomainZoneForm.php");

error_reporting(E_ALL ^ E_NOTICE);

session_start();

setup_user_environment();

$title = html_span("title");

$skin = Skin::Factory($user->color_template);

$content = container($title);

switch(strtolower($_REQUEST['action']))
{


case 'create':
    if(!$user->is_admin())
        header("Location: denied.php");
    $title->add(_("Creating Domain"));
    $content->add($title);
    $cd = new FormProcessor(new DomainCreateForm, "cdomain");
    $cd->set_render_form_after_success(false);
    $content->add(html_br(2), $cd, html_br(2));
    break;

case 'edit':
    if(!$user->is_admin())
        header("Location: denied.php");
    $title->add(_("Modifying Domain"));
    $content->add($title);
    //$am =& $skin->getActionMenu();
    //$am->add(html_a($_SERVER['SCRIPT_NAME']."?action=delete&amp;id=".$_REQUEST['id'], _("Delete")));
    //$content->add(html_br(2), $am, html_br()); 
    $content->add(html_br(2), Skin::amFactory(AM_EDIT, _("Domain")), html_br());

    $edf = new FormProcessor(new DomainEditForm, "edomain");
    $edf->set_render_form_after_success(false);

    $dzf = new FormProcessor(new DomainZoneForm, "domz");

    $content->add(html_br(2), $edf, html_br(2));
    if (!$edf->is_action_successfull())
        $content->add($dzf);

    break;

case 'delete':
    if (!$user->is_admin())
        header("Location: ".web_root()."denied.php");
    $title->add("Deleting Domain");
    $content->add($title);
    $dc = new FormProcessor(new MaintainDeleteConfirm("domain", "name"), "dcdomain");
    $dc->set_render_form_after_success(false);
    $content->add($dc);
    break;

case 'toggle_enable':
    if (!$user->is_admin())
        header("Location: ".web_root()."denied.php");

    toggleEnabled("domain", $_REQUEST['id']);    
    /* Ouch! */
    $_REQUEST['id'] = null;

case 'show':
case 'show_admin':

default:
        /* Action Jackson Menu */
         /*If user is admin show the "Create Domain" button */
    $am =& $skin->getActionMenu();
    if ($user->is_admin())  {
        if (isset($_REQUEST['id'])) 
            $am->add(html_a($_SERVER["SCRIPT_NAME"]."?action=edit&amp;id=".$_REQUEST['id'], _("Edit")));
        $am->add(html_a($_SERVER["SCRIPT_NAME"]."?action=create", _("Create Domain")));
    }
    if(isset($_REQUEST['id'])) {
        $domain = new Domain($_REQUEST['id']);
        $am->add(html_a($_SERVER["SCRIPT_NAME"]."?action=show", _("Show Domain Record List")));
        $content->add(html_br(2), $am, html_br(2));
        $content = Module::apply_filter("object_info",$content,$domain); 
    }
    else {
        $title->add(_("Showing Domains"));
        $content->add($title);
        
        $content->add(html_br(2), $am, html_br(2));
        $dl = new DomainDataList("Domains");
        $dl->user_setup();
        $content->add($dl);
    }   
    break;
}

function toggleEnabled($name, $id)
{
    $obj = new $name($id);
    $obj->setEnabled(!$obj->enabled);
    $obj->update();

}



print $skin->display($content);
?>
