<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/tags/release-3.0.0-RC1/htdocs/mx.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Michael Clay <claym@osuosl.org>                               |
// |          Zack Bartel  <bartel@osuosl.org>                              |
// +------------------------------------------------------------------------+
// $Id: mx.php 4656 2006-07-25 16:49:01Z claym $

/**
  * Mail Exchange (MX) Pages
  *
  * @package    htdocs
  */

require_once("includes.php");
require_once(HTCLASS."/datalist/MXDataList.php");
require_once(FORMDIR."/MXCreateForm.php");
require_once(FORMDIR."/MXEditForm.php");
require_once(FORMDIR."/MaintainDeleteConfirm.php");
require_once(FORMDIR."/ObjectMoveZoneForm.php");

error_reporting(E_ALL ^ E_NOTICE);
session_start();

setup_user_environment();

$title = html_span("title");

$skin = Skin::Factory($user->color_template);

$content = container();
switch(strtolower($_REQUEST['action'])) {

case 'edit':
    if(!$user->is_zone_user($zone))
        header("Location: denied.php");
    $title->add(_("Modifying MX Record"));
    $content->add($title);
    $content->add(html_br(2), Skin::amFactory(AM_EDIT,_("MX Record")), html_br(2));
    $content->add(show_live_time($_REQUEST['id'], _("MX Record")));

    $mef = new FormProcessor(new MXEditForm, "mxedit");
    $mef->set_render_form_after_success(false);
    $zonemove = new FormProcessor(new ObjectMoveZoneForm('mx', 'objmove'));
    if (!$zonemove->is_action_successfull())
        $content->add($mef);
    if (!$mef->is_action_successfull()) 
        $content->add($zonemove);
    
    break;

case 'delconfirm':
    if(!$user->is_zone_user($zone))
        header("Location: denied.php");
    $title->add(_("Deleting MX Record"));
    $content->add($title);
    $mdc = new FormProcessor(new MaintainDeleteConfirm("MX","Hostname"), "mxdel");
    $mdc->set_render_form_after_success(false);
    $content->add($mdc);
    break;

case 'create':
    if(!$user->is_zone_admin($zone))
        header("Location: denied.php");
    $title->add(_("Create an MX Record"));
    $content->add($title);
    
    $mcf = new FormProcessor(new MXCreateForm, "mxcreate");
    $mcf->set_render_form_after_success(false);
    $content->add($mcf);
    break;

case 'show':

default:
    if(isset($_REQUEST['id'])) {
        $title->add(_("Displaying MX Record"));
        $mx = new MX($_REQUEST['id']);
        $content->add($title);
        $content->add(html_br(2), Skin::amFactory(AM_SHOW,_("MX Record")), html_br(2));
        $content->add(show_live_time($_REQUEST['id'], _("MX Record")));
        $content = Module::apply_filter("object_info",$content,$mx); 
    }
    else {
        $title->add(_("Listing MX Records for Current Zone"));
        $ml = new MXDataList("MX");
        $ml->user_setup();
        $content->add($title);
        $content->add(html_br(2), Skin::amFactory(AM_LIST,_("MX Record")), html_br(2));
        $content->add($ml);
    }
}

print $skin->display($content);

?>
