<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/trunk/htdocs/ns.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Michael Clay <claym@osuosl.org>                               |
// |          Zack Bartel <bartel@osuosl.org>                               |
// |          Josh Schonstal <schonstal@osuosl.org>                         |
// +------------------------------------------------------------------------+ 
// $Id: ns.php 4669 2006-07-25 21:58:27Z morgabra $

/**
  * Host pages
  *
  * @package    htdocs
  */

require_once("includes.php");
require_once(FORMDIR."/NameserverCreateForm.php");
require_once(HTCLASS."/datalist/NameserverDataList.php");
require_once(FORMDIR."/NameserverDeleteConfirm.php");
require_once(FORMDIR."/NameserverEditForm.php");

error_reporting(E_ALL ^ E_NOTICE);
session_start();

setup_user_environment();

$title = html_span("title");

$skin = Skin::Factory($user->color_template); 

$content = container();

$res = true;  //Result for errors

switch(strtolower($_REQUEST['action'])) {

case 'edit':
    $title->add(_("Modifying Nameserver"));
    $content->add($title);
    
     if(!$user->is_admin() || !isset($_REQUEST['id']))
        header("Location: denied.php");
        
    $ns = new NS($_REQUEST['id']);
        
    $nsdf = new FormProcessor(new NameserverEditForm(),"nsedit");
    $nsdf->set_render_form_after_success(false);
    
    $content->add(html_br(), $nsdf);

    break;
    
case 'delconfirm':

    $title->add(_("Deleting Nameserver"));
    $content->add($title);
        
    $dcf = new FormProcessor(new NameserverDeleteConfirm(), "delconfirm");
    $dcf->set_render_form_after_success(false);
    $content->add($dcf);
    break;

case 'create':
    $title->add(_("Creating Nameserver"));
    $content->add($title);
    $am =& $skin->getActionMenu(); 
    $showall_link = html_a($_SERVER["SCRIPT_NAME"]."?action=show",_("Show Nameserver List"));
    $am->add($showall_link);
    $content->add(html_br(2), $am, html_br(2));

    /* Check admin status */
    if (!$user->is_admin())
        header("Location: denied.php");
    $nscf = new FormProcessor(new NameserverCreateForm(), "create");
    $nscf->set_render_form_after_success(false);
    if(!$nscf->is_action_successfull())
        $content->add($viewlinks);
    $content->add($nscf);
    
    break;

case 'show':

default:

    $title->add(_("Showing Nameservers"));
    $content->add($title);
    
    /* If you aren't a zone user then gtfo */
    if(!$user->is_admin())
        header("Location: denied.php");
    
        /* Action Menu */
        $am =& $skin->getActionMenu();
        $am->add(html_a($_SERVER["SCRIPT_NAME"]."?action=create",_("Create a new Nameserver")));
        $content->add(html_br(2),$am,html_br(2));
        if($res !== true) {
            $error = html_span('error');
            $error->add($res);
            $content->add($error,html_br(2));
        }
        $nsl = new NameserverDataList("Nameservers","100%","name");
        $nsl->user_setup();
        $content->add($nsl);
    
    break;
    
}

print $skin->display($content);
?>
