<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/tags/release-3.0.0-RC1/htdocs/range.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Michael Clay <claym@osuosl.org>                               |
// |          Zack Bartel  <bartel@osuosl.org>                              |
// +------------------------------------------------------------------------+
// $Id: range.php 4656 2006-07-25 16:49:01Z claym $

/**
 *  Range.php - This file is the controller for ranges
 *
 *  @package    htdocs
 *  @author     $Author: claym $
 *  @filesource
 */

require_once("includes.php");
require_once(HTCLASS."/datalist/RangeDataList.php");
require_once(FORMDIR."/RangeCreateForm.php");
require_once(HTCLASS."/datalist/ZoneRangeDataList.php");
require_once(FORMDIR."/RangeEditForm.php");
require_once(FORMDIR."/RangeSplitForm.php");
require_once(FORMDIR."/RangeMergeForm.php");
require_once(FORMDIR."/RangeZoneAddForm.php");
require_once(FORMDIR."/ZoneRangeBulkDeleteConfirm.php");
require_once(FORMDIR."/MaintainDeleteConfirm.php");
require_once(HTCLASS."/datalist/RangeAvailableIPsDataList.php");

//error_reporting(E_ALL ^ E_NOTICE);

session_start();

setup_user_environment();

$title = html_span("title");

$skin = Skin::Factory($user->color_template);

$content = container();

switch(strtolower($_REQUEST['action'])) {

case 'create':
    if(!$user->is_admin())
        header("Location: ".web_root()."denied.php");
    $title->add(_("Create Range"));
    $content->add($title);
    $rcf = new FormProcessor(new RangeCreateForm, "rangecreate");
    $rcf->set_render_form_after_success(false);
    $content->add($rcf);
    break;

case 'split':
    if (!$user->is_admin())
        header("Location: ".web_root()."denied.php");

    $title->add(_("Split IP Range"));
    $content->add($title);
    $rsf = new FormProcessor(new RangeSplitForm, "rangesplit");
    $rsf->set_render_form_after_success(false);
    $content->add($rsf);
    break;

case 'merge':
    if (!$user->is_admin())
        header("Location: ".web_root()."denied.php");

    $title->add(_("Merge IP Ranges"));

    $rmf = new FormProcessor(new RangeMergeForm, "rangemerge");
    $rmf->set_render_form_after_success(false);
    $content->add($rmf);
    break;

case 'zone_range_endis':
    if (!$user->is_admin())
        header("Location: ".web_root()."denied.php"); 
    
    toggleEnabled($_REQUEST['zrid']);
    /* Take this out if we don't like it */
    header("Location: ".web_root()."range.php?action=edit&id=".$_REQUEST['id']);
    
case 'edit':
    if(!$user->is_admin())
        header("Location: ".web_root()."denied.php");
    $title->add(_("Modifying Range"));
    $content->add($title,html_br(2));
    /* We might have returned to the page w/o an id, happens when you hit
       "Delete Zones" with no zones selected". There has got to be a better way.
    */
    //if ($_REQUEST['id'] == '')
        //header("Location: ".$HTTP_REFERER);
    $ref = new FormProcessor(new RangeEditForm, "rangeedit");     
    $ref->set_render_form_after_success(false);
    $content->add($ref,html_br(2));

    /* If the edit form is submitted then we don't want to show this */
    if (!$ref->is_action_successfull())    {
        $zrdl = new ZoneRangeDataList(_("Zones for this Range"));
        $zrdl->user_setup();
        $zrtitle = html_span("title");
        $zrtitle->add(_("Zone to Range Mapping"));
        $content->add($zrtitle, html_br(2), $zrdl);
        $content->add(html_br(2));
        $zaf = new FormProcessor(new RangeZoneAddForm, "zonerangeadd");
        $content->add($zaf);
    }

    break;

case 'delete zones':
    if(!$user->is_admin())
        header("Location: ".web_root()."denied.php");
    $zrids = $_REQUEST['zrmaps'];
    $content->add(new FormProcessor(new ZoneRangeBulkDeleteConfirm($zrids),"zonerangedel"));
    break;

case 'avail':
    $rail = new RangeAvailableIPsDataList(_("Available IPs"));
    //$rail->_range = new Range($_REQUEST['id']);
    $title->add(_("Available IP addresses in static IP range")." ".IP::int2ip($rail->_range->start)." - ".IP::int2ip($rail->_range->end));
    $content->add($title);
    $content->add($rail);
    break;

//TODO: How to handle error when trying to delete last zone
case 'zone_range_delconfirm':
    if (!$user->is_admin())
        header("Location: ".web_root()."denied.php"); 

    $zrids = array($_REQUEST['zrid']);
    $zrbdf = new FormProcessor(new ZoneRangeBulkDeleteConfirm($zrids), "zonerangedel");
    $content->add($zrbdf);
    break;

case 'delconfirm':
    if (!$user->is_admin())
        header("Location: ".web_root()."denied.php"); 

    $title->add(_("Deleting Range"));
    $content->add($title);
    $rdc = new FormProcessor(new MaintainDeleteConfirm("Range", "DisplayDelete"), "rangedelete");
    $rdc->set_render_form_after_success(false);
    $content->add($rdc);
    break;

case 'show':
case 'show_admin':

default:
    if(!$user->is_guest())
        header("Location: denied.php");
    if(isset($_REQUEST['id'])) {
        $title->add(_("View Range"));
        $content->add($title);
        $range = new Range($_REQUEST['id']);
        $content = Module::apply_filter("object_info",$content,$range); 
    }
    else {
        $title->add(_("Viewing Ranges"));
        $content->add($title);
        $rl = new RangeDataList("Ranges");
        $rl->user_setup();
        $content->add(html_br(2),Skin::amFactory(AM_LIST, "Range"),html_br(2));
        $content->add($rl);
    }
}
function toggleEnabled($id)
{
    $obj = DB_DataObject::Factory('zone_range');
    $obj->get($id);
    $obj->enabled = !$obj->enabled;
    $obj->update();
}

print $skin->display($content);

?>
